Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 214934)
+++ channels/chan_sip.c	(working copy)
@@ -21512,6 +21512,26 @@
 			if (IS_SIP_TECH(bridge->tech) && q && q->rtp) {
 				ast_rtp_instance_set_stats_vars(bridge, q->rtp);
 			}
+
+			const char *srbh = pbx_builtin_getvar_helper(bridge, "SIPREMOTEBYEHEADER");
+			if (!ast_strlen_zero(srbh)) {
+				char workspace[1024], request[128];
+				char *varname;
+				char *header = ast_strdup(srbh);
+				if ( (varname = strchr(header, ',')) ) {
+					*varname = '\0';
+					varname++;
+					snprintf(request, sizeof(request), "SIP_HEADER(%s)", header);
+					ast_func_read(p->owner, request, workspace, sizeof(workspace));
+					ast_log(LOG_DEBUG, "Requested header '%s' contain '%s'\n", header, workspace);
+					if (!ast_strlen_zero(varname)) {
+						pbx_builtin_setvar_helper(bridge, varname, workspace);
+						ast_log(LOG_DEBUG, "Setting var '%s' to '%s'\n", varname, workspace);
+					}
+				} else {
+					ast_log(LOG_DEBUG, "SIPREMOTEBYEHEADER ('%s') is malformed\n", srbh);
+				}
+			}
 			ast_channel_unlock(bridge);
 		}
 
